var rolledValues = [];
var selectedValues = [];
var needsToRoll = true;
var lockedIn = false;
var bonusYahtzee = 0;

function rollDice() {
	playAudio('/android_asset/www/dice-roll.mp3');
	needsToRoll = false;

	var random1 = Math.floor((Math.random() * 6) + 1);
	var random2 = Math.floor((Math.random() * 6) + 1);
	
	//Push new roll values into array after clearing it
	rolledValues = [];
	rolledValues.push(random1);
	rolledValues.push(random2);
	
	diceSprite('#rolledDice1', random1);
	diceSprite('#rolledDice2', random2);
	
	//Decrement multiplier after roll
	setMultiplier('4');
	
	//After rolling, hide Roll button and show the Confirm button and The Flop button
	$('#rollBtn').hide();
	$('#theFlop').show();
	
	updateScores();
}

function showFlop() {
	playAudio('/android_asset/www/dice-roll.mp3');
	var random1 = Math.floor((Math.random() * 6) + 1);
	var random2 = Math.floor((Math.random() * 6) + 1);
	var random3 = Math.floor((Math.random() * 6) + 1);
	
	$('#flop1, #flop2, #flop3').addClass('background-url');
	diceSprite('#flop1', random1);
	diceSprite('#flop2', random2);
	diceSprite('#flop3', random3);
	
	//Decrement multiplier after roll
	decMultiplier();
	
	//After the flop, show selects, hide The Flop button and show The Turn button
	$('#select1, #select2, #select3').css('visibility', 'visible');
	$('#theFlop').hide();
	$('#theTurn').show();
	
	updateScores();
}

function showTurn() {
	playAudio('/android_asset/www/dice-roll.mp3');
	var random = Math.floor((Math.random() * 6) + 1);
	
	$('#turn').addClass('background-url');
	diceSprite('#turn', random);
	
	//Decrement multiplier after roll
	decMultiplier();
	
	//After the turn, show select, hide The Turn button and show The River button
	$('#select4').css('visibility', 'visible');
	$('#theTurn').hide();
	$('#theRiver').show();
	
	updateScores();
}

function showRiver() {
	playAudio('/android_asset/www/dice-roll.mp3');
	var random = Math.floor((Math.random() * 6) + 1);
	
	$('#river').addClass('background-url');
	diceSprite('#river', random);
	
	//Decrement multiplier after roll
	decMultiplier();
	
	//After the river, show select and hide The River button
	$('#select5').css('visibility', 'visible');
	$('#theRiver').hide();
	
	updateScores();
}

function diceSprite(id, newValue) {
	var count = 0;
	var startPos = -1;
	var currPos = startPos;
	
	var interval = setInterval(function() {
		if(currPos <= -286) {
			newPos = -1;
		} else {
			var newPos = currPos - 57;
		}
		$(id).css('background-position', newPos + 'px -1px');
		currPos = newPos;
		
		//Count to 5 -> 5 * 100 = 500 -> about half a second of sprite animation
		if(count >= 5) {
			clearInterval(interval);
			$(id).css('background-position', '');
			setDice(id, newValue);	//After sprite completes, set dice to new value
		} else {
			count++;
		}
	}, 100);
}

function setDice(id, num) {
	$(id).removeClassPrefix('dice');
	var diceClass = 'dice' + num;
	$(id).addClass('dice ' + diceClass);
	$(id).data('value', num);
}

function setMultiplier(val) {
	$('#multiplier').html(val);
}

function decMultiplier() {
	if(!lockedIn) {
		var multiplier = $('#multiplier').html();
		$('#multiplier').html(multiplier - 1);
	}
}

function updateScores() {
	//Checks the Upper Section (left column)
	$('.scorecard1 .value').each(function(i) {
		if(!$(this).parent().hasClass('confirmed')) {
			$(this).html(checkUpperScore(i+1));
		}
	});
	//End Upper Section checks
	
	//Checks for Lower Section (right column)
	$('.scorecard2 .value').each(function(i) {
		if(!$(this).parent().hasClass('confirmed') || $(this).parent().hasClass('yahtzee-bonus')) {
			$(this).html(checkLowerScore(i));
		}
	});
	//End Lower Section checks
}

function checkUpperScore(num) {
	var rollValue = 0;
	var fieldValue = 0;
	var multiplier = $('#multiplier').html();
	
	for(var i = 0; i < rolledValues.length; i++) {
		if(rolledValues[i] == num) {
			rollValue += num;
		}
	}
	for(var i = 0; i < selectedValues.length; i++) {
		if(selectedValues[i] == num) {
			fieldValue += num;
		}
	}
	
	if(fieldValue > (3 * num)) { fieldValue = (3 * num); }
	
	return (rollValue + fieldValue) * multiplier;
}

function getJoinedDice() {
	var result = rolledValues.concat(selectedValues);
	result.sort();
	return result.join("");
}

function checkLowerScore(num) {
	var result = 0;
	var multiplier = $('#multiplier').html();
	var allDice = rolledValues.concat(selectedValues);
	
	switch(num) {
		case 0:
			result = checkThreeKind(getJoinedDice()) * multiplier
			break;
		case 1:
			result = checkFourKind(getJoinedDice()) * multiplier
			break;
		case 2:
			result = checkFullHouse(getJoinedDice()) * multiplier;
			break;
		case 3:
			result = checkSmStraight(getJoinedDice()) * multiplier;
			break;
		case 4:
			result = checkLgStraight(getJoinedDice()) * multiplier;
			break;
		case 5:
			result = checkYahtzee(getJoinedDice()) * multiplier;
			break;
		case 6:
			result = checkChance(allDice) * multiplier;
			break;
		case 7:
			result = bonusYahtzee + (checkBonusYahtzee(getJoinedDice()) * multiplier);
			break;
		default:
			break;
	}
	
	return result;
}

function updateTotals() {
	var upperTotal = 0;
	var bonus = $('#bonus').html() || 0;
	var lowerTotal = 0;
	var grandTotal = 0;
	
	$('.scorecard1 .value').each(function(i) {
		if($(this).parent().hasClass('confirmed')) {
			upperTotal += parseInt($(this).html());
		}
	});
	
	if(upperTotal >= 126) {
		bonus = 70;
		$('#bonus').html(bonus);
	}
	
	$('.scorecard2 .value').each(function(i) {
		if($(this).parent().hasClass('confirmed')) {
			lowerTotal += parseInt($(this).html());
		}
	});
	
	grandTotal = upperTotal + bonus + lowerTotal;
	
	$('#total').html(upperTotal);
	$('#totalUpper').html(upperTotal + bonus);
	$('#totalLower').html(lowerTotal);
	$('#grandTotal').html(grandTotal);
}

function checkThreeKind(allDice) {
	var result = 0;
	
	if(/(.)\1{2}/.test(allDice)) {
		for(var i = 0; i < allDice.length; i++) {
			result += parseInt(allDice.charAt(i));
		}
	}
	
	return result;
}
function checkFourKind(allDice) {
	var result = 0;
	
	if(/(.)\1{3}/.test(allDice)) {
		for(var i = 0; i < allDice.length; i++) {
			result += parseInt(allDice.charAt(i));
		}
	}
	
	return result;
}
function checkFullHouse(allDice) {
	var result = 0;
	
	if(/(.)\1{2}(.)\2|(.)\3(.)\4{2}/.test(allDice)) {
		result = 25;
	}
	
	return result;
}
function checkSmStraight(allDice) {
	var result = 0;
	
	if(/1234|2345|3456/.test(allDice.replace(/(.)\1/,"$1"))) {
		result = 30;
	}
	
	return result;
}
function checkLgStraight(allDice) {
	var result = 0;
	
	if(/12345|23456/.test(allDice)) {
		result = 40;
	}
	
	return result;
}
function checkYahtzee(allDice) {
	var result = 0;
	
	if(/(.)\1{4}/.test(allDice)) {
		result = 50;
	}
	
	return result;
}
function checkChance(allDice) {
	var result = 0;
	
	for(var i = 0; i < allDice.length; i++) {
		result += allDice[i];
	}
	
	return result;
}
function checkBonusYahtzee(allDice) {
	var result = 0;
	
	//Make sure Yahtzee has been hit or Bonus Yahtzee is 0
	if($('#yahtzee').parent().hasClass('confirmed') && parseInt($('#yahtzee').html()) > 0) {
		if(/(.)\1{4}/.test(allDice)) {
			result = 100;
		}
	}
	
	return result;
}

function resetRoll() {
	needsToRoll = true;
	lockedIn = false;
	
	$('#confirm, #theFlop, #theTurn, #theRiver').hide();
	$('#rollBtn').show();
	
	setMultiplier('-');	//Reset multiplier to 4
	
	//Clear out possible scores
	rolledValues = [];
	selectedValues = [];
	$('.points-row').each(function(i) {
		if(!$(this).hasClass('confirmed')) {
			$(this).find('.value').html('');
		}
	});
	if($('.yahtzee-bonus').hasClass('confirmed')) {
		$('#yahtzeeBonus').html(bonusYahtzee);
	} else {
		$('#yahtzeeBonus').html('');
	}
	
	//Clear out the play field dice
	$('.field-dice').each(function(i) {
		$(this).data('value', '');
		$(this).html('');
		$(this).removeClass('green-shadow background-url').addClass('red-shadow');
	});
	
	//Reset check marks and hide them
	$('.select-btn').each(function(i) {
		$(this).removeClass('glyphicon-ok-circle').addClass('glyphicon-remove-circle');
		$(this).css('visibility', 'hidden');
	});
}

function checkGameOver() {
	var gameOver = true;
	
	$('.points-row').each(function(i) {
		if(!$(this).hasClass('confirmed')) {
			gameOver = false;
		}
	});
	
	return gameOver;
}

function getHighScores() {
	$('#highScore1').html(localStorage.getItem('highScore1') || 0);
	$('#highScore2').html(localStorage.getItem('highScore2') || 0);
	$('#highScore3').html(localStorage.getItem('highScore3') || 0);
}

function updateHighScores() {
	var highScore1 = localStorage.getItem('highScore1') || 0;
	var highScore2 = localStorage.getItem('highScore2') || 0;
	var highScore3 = localStorage.getItem('highScore3') || 0;
	var currScore = $('#grandTotal').html();
	var newHighScore = false;
	
	if(currScore > highScore1) {
		//Remove previous 3rd score and move the other 2 down
		highScore3 = highScore2;
		highScore2 = highScore1;
		highScore1 = currScore;
		
		//Replace in high score table
		$('#highScore1').html(highScore1);
		$('#highScore2').html(highScore2);
		$('#highScore3').html(highScore3);
		
		//Replace in local storage
		localStorage.setItem('highScore1', highScore1);
		localStorage.setItem('highScore2', highScore2);
		localStorage.setItem('highScore3', highScore3);
		
		newHighScore = true;
	} else if(currScore > highScore2) {
		//Remove previous 3rd score and move 2 down to 3
		highScore3 = highScore2;
		highScore2 = currScore;
		
		//Replace in high score table
		$('#highScore2').html(highScore2);
		$('#highScore3').html(highScore3);
		
		//Replace in local storage
		localStorage.setItem('highScore2', highScore2);
		localStorage.setItem('highScore3', highScore3);
		
		newHighScore = true;
	} else if(currScore > highScore3) {
		//Replace 3rd score
		highScore3 = currScore;
		
		//Replace in high score table
		$('#highScore3').html(highScore3);
		
		//Replace in local storage
		localStorage.setItem('highScore3', highScore3);
		
		newHighScore = true;
	}
	
	return newHighScore;
}

function resetHighScores() {
	var confirm = window.confirm("Be careful! You are about to reset your high scores!");
	if(confirm) {
		localStorage.removeItem("highScore1");
		localStorage.removeItem("highScore2");
		localStorage.removeItem("highScore3");
		getHighScores();
	}
}
function mainMenu() {
	navigator.notification.confirm(
		"Are you sure you want to end this game?",	//message
		confirmMainMenu,	//callback function
		"Confirmation",	//title
		"Yes, No"	//button labels
	);
}
function confirmMainMenu(btnIndex) {
	if(btnIndex == 1) {
		location.href = "index.html";
	}
}
function exitApp() {
	navigator.notification.confirm(
		"Are you sure you want to exit?", //message
		confirmExit,	//callback function
		"Confirmation",	//title
		"Yes, No"	//button labels
	);
}
function confirmExit(btnIndex) {
	if(btnIndex == 1) {
		navigator.app.exitApp();
	}
}

//Custom jQuery function to remove all classes with certain prefix
$.fn.removeClassPrefix = function(prefix) {
    this.each(function(i, el) {
        var classes = el.className.split(" ").filter(function(c) {
            return c.lastIndexOf(prefix, 0) !== 0;
        });
        el.className = $.trim(classes.join(" "));
    });
    return this;
};

$(document).ready(function() {
	$('.field-dice').click(function() {
		//Make sure this field has a dice in it/has been rolled
		if($(this).data('value') <= 0) {
			window.alert("This dice has not been revealed yet");
		}
		else if($(this).hasClass('red-shadow')) {	//Selecting dice
			//Make sure 3 dice have not already been selected from the field
			if(selectedValues.length < 3) {
				playAudio('/android_asset/www/clip.mp3');
				$(this).removeClass('red-shadow').addClass('green-shadow');
				selectedValues.push($(this).data('value'));	//Add selected value to selectedValues array
			} else {
				window.alert("You have already selected three dice to use with your roll");
			}
		} else {	//Deselecting dice
			playAudio('/android_asset/www/blop.mp3');
			$(this).removeClass('green-shadow').addClass('red-shadow');
			//Get index of deselected value and remove it from the selectedValues array
			var index = selectedValues.indexOf($(this).data('value'));
			selectedValues.splice(index, 1);
		}
		
		updateScores();	//Update possible scores after select or deselects
	});
	
	$('.value').parent().click(function() {
		//Make sure user is eligible to select - prevents multiple selections from one turn
		if(needsToRoll) {
			window.alert("You have not rolled yet");
		} else {
			var value = $(this).find('.value');
			//Make sure this hasn't already been selected
			if($(this).hasClass('confirmed') && !$(this).hasClass('yahtzee-bonus')) {
				var text = value.prev('td').html();
				var substring = text.substring(0, text.indexOf('&'));
				window.alert("You have already selected your " + substring);
			} else {
				var multiplier = $('#multiplier').html();
				//Make sure user isn't already locked in to another item
				if(lockedIn) {
					var lockedItem = $('.locked').find('.row-label').html();
					window.alert("You are already locked in to " + lockedItem + " with a multiplier of " + multiplier);
				} else {
					//If this is bonus yahtzee, make sure player has already yahtzee'd and currently has rolled a yahtzee
					if($(this).hasClass('yahtzee-bonus') && (!$('#yahtzee').parent().hasClass('confirmed') || parseInt($('#yahtzee').html()) <= 0)) {
						window.alert("You must Yahtzee before Bonus Yahtzee is available");
					} else if($(this).hasClass('yahtzee-bonus') && checkBonusYahtzee(getJoinedDice()) <= 0) {
						window.alert("You must currently have a Yahtzee to select Bonus Yahtzee");
					} else {
						var confirm = window.confirm("You are about to lock in " + $(this).find('.row-label').html() + " with a multiplier of " + multiplier);
						if(confirm) {
							playAudio('/android_asset/www/hole-punch.mp3');
							lockedIn = true;
							$(this).addClass('locked');
							$('#confirm').show();
						}
					}
				}
			}
		}
	});
	
	$('#confirmBtn').click(function() {
		playAudio('/android_asset/www/ting.mp3');
		var item = $('.locked');
		var value = item.find('.value');
		item.removeClass('locked').addClass('confirmed');
		//Do not show multiplier for Bonus Yahtzee
		if(!item.hasClass('yahtzee-bonus')) {
			item.find('.row-label').html(item.find('.row-label').html() + '&nbsp;<span class="multiplier">x ' + $('#multiplier').html() + '</span>');
		} else {
			bonusYahtzee = parseInt(value.html());
		}
		//Update Totals
		updateTotals();
		//Check to see if all items have been selected - game over
		if(!checkGameOver()) {
			resetRoll();
		} else {
			$('.row').hide();
			$('.table-wrapper, #playAgain').show();
			
			if(updateHighScores()) {
				window.alert("You set a new high score!");
			} else {
				window.alert("And...that's the game!");
			}
		}
	});
	
	$('#playAgain').click(function() {
		window.location.reload();
	});
	
	$(document).click(function() {
		$('.navbar-collapse').collapse('hide');
	});
	
	getHighScores();
});